RainbowKeyPairGenerator (Bouncy Castle Library 1.54 API Specification)
Date: 2015-12-29

org.bouncycastle.pqc.crypto.rainbow

## Class RainbowKeyPairGenerator

- java.lang.Object
- - org.bouncycastle.pqc.crypto.rainbow.RainbowKeyPairGenerator

- All Implemented Interfaces:
    AsymmetricCipherKeyPairGenerator

      public class RainbowKeyPairGenerator
      extends java.lang.Object
      implements AsymmetricCipherKeyPairGenerator

  This class implements AsymmetricCipherKeyPairGenerator. It is used as a generator for the private and public key of the Rainbow Signature Scheme.

  Detailed information about the key generation is to be found in the paper of Jintai Ding, Dieter Schmidt: Rainbow, a New Multivariable Polynomial Signature Scheme. ACNS 2005: 164-175 (http://dx.doi.org/10.1007/11496137_12)

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `RainbowKeyPairGenerator()` The standard constructor tries to generate the Rainbow algorithm identifier with the corresponding OID.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `AsymmetricCipherKeyPair` | `generateKeyPair()` return an AsymmetricCipherKeyPair containing the generated keys.
    `AsymmetricCipherKeyPair` | `genKeyPair()` This function generates a Rainbow key pair.
    `void` | `init(KeyGenerationParameters param)` intialise the key pair generator.
    `void` | `initialize(KeyGenerationParameters param)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### RainbowKeyPairGenerator

          public RainbowKeyPairGenerator()

      The standard constructor tries to generate the Rainbow algorithm identifier with the corresponding OID.

  - ### Method Detail

    - #### genKeyPair

          public AsymmetricCipherKeyPair genKeyPair()

      This function generates a Rainbow key pair.
      Returns:
        the generated key pair

    - #### initialize

          public void initialize(KeyGenerationParameters param)

    - #### init

          public void init(KeyGenerationParameters param)

      Description copied from interface: `AsymmetricCipherKeyPairGenerator`
      intialise the key pair generator.
      Specified by:
        `init` in interface `AsymmetricCipherKeyPairGenerator`
      Parameters:
        `param` - the parameters the key pair is to be initialised with.

    - #### generateKeyPair

          public AsymmetricCipherKeyPair generateKeyPair()

      Description copied from interface: `AsymmetricCipherKeyPairGenerator`
      return an AsymmetricCipherKeyPair containing the generated keys.
      Specified by:
        `generateKeyPair` in interface `AsymmetricCipherKeyPairGenerator`
      Returns:
        an AsymmetricCipherKeyPair containing the generated keys.